<?php

namespace Lean\Console\Lib\Database;

class DefinitionCollection extends \Ulmus\EntityCollection
{
    public function filterType(ModifierTypeEnum $type) : self
    {
        return $this->filtersCollection(fn(Definition $e) => $e->modifier->type === $type);
    }

    public function filterCreate() : self
    {
        return $this->filterType(ModifierTypeEnum::Create);
    }

    public function filterAlter() : self
    {
        return $this->filterType(ModifierTypeEnum::Alter);
    }

    public function filterDelete() : self
    {
        return $this->filterType(ModifierTypeEnum::Delete);
    }
}